Index: java/main/src/main/java/com/framsticks/gui/console/TrackConsole.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/console/TrackConsole.java	(revision 97)
+++ java/main/src/main/java/com/framsticks/gui/console/TrackConsole.java	(revision 97)
@@ -0,0 +1,43 @@
+package com.framsticks.gui.console;
+
+import com.framsticks.communication.Connection;
+import com.framsticks.communication.ConnectionListener;
+import com.framsticks.params.annotations.AutoAppendAnnotation;
+import com.framsticks.params.annotations.FramsClassAnnotation;
+
+@FramsClassAnnotation
+public class TrackConsole extends Console implements ConnectionListener {
+
+	public TrackConsole() {
+	}
+
+	@AutoAppendAnnotation
+	public TrackConsole setConnection(Connection connection) {
+		this.connection = connection;
+		return this;
+	}
+
+	@Override
+	protected void joinableStart() {
+		super.joinableStart();
+		connection.getListeners().add(this);
+	}
+
+	@Override
+	protected void joinableInterrupt() {
+		connection.getListeners().remove(this);
+		super.joinableInterrupt();
+	}
+
+
+	@Override
+	public void connectionOutgoing(String line) {
+		dispatchWrite(line);
+	}
+
+	@Override
+	public void connectionIncomming(String line) {
+		dispatchWrite(line);
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/gui/controls/Control.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/controls/Control.java	(revision 96)
+++ java/main/src/main/java/com/framsticks/gui/controls/Control.java	(revision 97)
@@ -6,7 +6,8 @@
 import javax.swing.JPanel;
 
-import com.framsticks.gui.Frame;
 import com.framsticks.params.Flags;
 import com.framsticks.params.Param;
+import com.framsticks.util.FramsticksException;
+import com.framsticks.util.dispatching.ExceptionResultHandler;
 
 /**
@@ -14,5 +15,5 @@
  */
 @SuppressWarnings("serial")
-public abstract class Control extends JPanel {
+public abstract class Control extends JPanel implements ExceptionResultHandler {
 
 	public static final int LINE_HEIGHT = 36;
@@ -20,5 +21,4 @@
 	// private static final Logger log = Logger.getLogger(Control.class.getName());
 
-	protected Frame frame;
 	protected final Param param;
 	protected ControlOwner owner;
@@ -36,8 +36,4 @@
 	}
 
-	public void setFrame(Frame frame) {
-		this.frame = frame;
-	}
-
 	public void setOwner(ControlOwner owner) {
 		this.owner = owner;
@@ -53,3 +49,8 @@
 		return param.toString();
 	}
+
+	@Override
+	public void handle(FramsticksException exception) {
+		owner.handle(exception);
+	}
 }
Index: java/main/src/main/java/com/framsticks/gui/controls/ControlOwner.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/controls/ControlOwner.java	(revision 96)
+++ java/main/src/main/java/com/framsticks/gui/controls/ControlOwner.java	(revision 97)
@@ -4,6 +4,7 @@
 
 import com.framsticks.gui.TreeNode;
+import com.framsticks.util.dispatching.ExceptionResultHandler;
 
-public interface ControlOwner {
+public interface ControlOwner extends ExceptionResultHandler {
 
 	public JPanel getPanel();
Index: java/main/src/main/java/com/framsticks/gui/controls/ProcedureControl.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/controls/ProcedureControl.java	(revision 96)
+++ java/main/src/main/java/com/framsticks/gui/controls/ProcedureControl.java	(revision 97)
@@ -1,5 +1,5 @@
 package com.framsticks.gui.controls;
 
-import com.framsticks.core.Instance;
+import com.framsticks.core.Tree;
 import com.framsticks.core.Path;
 import com.framsticks.gui.Gui;
@@ -8,8 +8,8 @@
 import com.framsticks.params.ValueParam;
 import com.framsticks.params.types.ProcedureParam;
-import com.framsticks.util.FramsticksException;
-import com.framsticks.util.Logging;
-import com.framsticks.util.dispatching.Future;
+import com.framsticks.util.dispatching.ExceptionResultHandler;
+import com.framsticks.util.dispatching.FutureHandler;
 import com.framsticks.util.dispatching.RunAt;
+import com.framsticks.util.dispatching.ThrowExceptionHandler;
 
 import javax.swing.*;
@@ -58,20 +58,19 @@
 
 				log.debug("calling " + getParam() + " on " + treeNode);
-				final Path path = treeNode.getInstancePath();
+				final Path path = treeNode.getTreePath();
 
 				final List<Object> arguments = new LinkedList<Object>();
 				for (Param arg : getParam().getArgumentsType()) {
-					arguments.add(((ValueControl) components.get(arg)).getCurrentValue());
+					Object value = components.get(arg).getCurrentValue();
+					arguments.add(value);
+					log.debug("argument " + arg + ": " + value);
 				}
+				//TODO FEH: make it show dialog
+				final ExceptionResultHandler handler = ThrowExceptionHandler.getInstance();
 
-				path.getInstance().dispatch(new RunAt<Instance>() {
+				path.getTree().dispatch(new RunAt<Tree>(handler) {
 					@Override
-					public void run() {
-						path.getInstance().call(path, getParam(), arguments.toArray(), new Future<Object>() {
-
-							@Override
-							public void handle(FramsticksException e) {
-								Logging.log(log, "call procedure", path, e);
-							}
+					protected void runAt() {
+						path.getTree().call(path, getParam(), arguments.toArray(), new FutureHandler<Object>(handler) {
 
 							@Override
Index: java/main/src/main/java/com/framsticks/gui/controls/SliderControl.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/controls/SliderControl.java	(revision 96)
+++ java/main/src/main/java/com/framsticks/gui/controls/SliderControl.java	(revision 97)
@@ -104,5 +104,5 @@
 
 		JPanel sliderPanel = new JPanel();
-		sliderPanel.setLayout(new BoxLayout(sliderPanel, BoxLayout.LINE_AXIS));
+		// sliderPanel.setLayout(new BoxLayout(sliderPanel, BoxLayout.LINE_AXIS));
 
 
Index: java/main/src/main/java/com/framsticks/gui/controls/TextAreaControl.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/controls/TextAreaControl.java	(revision 96)
+++ java/main/src/main/java/com/framsticks/gui/controls/TextAreaControl.java	(revision 97)
@@ -9,12 +9,11 @@
 public class TextAreaControl extends TextControl {
 
-	// private static final Logger log = Logger.getLogger(TextAreaControl.class.getName());
-
-	protected JTextArea textArea;
-	protected JScrollPane textScrollPane;
+	protected final JTextArea textArea;
+	protected final JScrollPane textScrollPane;
 
 	public TextAreaControl(PrimitiveParam<?> valueParam) {
 		super(valueParam);
 		textArea = new JTextArea();
+		textArea.setName("value");
 		textArea.setLineWrap(true);
 		textArea.setWrapStyleWord(true);
Index: java/main/src/main/java/com/framsticks/gui/controls/ValueControl.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/controls/ValueControl.java	(revision 96)
+++ java/main/src/main/java/com/framsticks/gui/controls/ValueControl.java	(revision 97)
@@ -7,4 +7,5 @@
 import com.framsticks.params.PrimitiveParam;
 import com.framsticks.params.ReassignResult;
+import com.framsticks.util.FramsticksException;
 import com.framsticks.util.swing.TooltipConstructor;
 
@@ -73,5 +74,6 @@
 			return res.getValue();
 		} catch (CastFailure e) {
-			log.error("cast failure when setting param " + param + " to value " + candidate + ": " + e);
+			//TODO just throw here, but check where that function is being used
+			handle(new FramsticksException().msg("invalid value in control").arg("param", param).arg("value", candidate).cause(e));
 		}
 		return oldValue;
Index: java/main/src/main/java/com/framsticks/hosting/ClientAtServer.java
===================================================================
--- java/main/src/main/java/com/framsticks/hosting/ClientAtServer.java	(revision 97)
+++ java/main/src/main/java/com/framsticks/hosting/ClientAtServer.java	(revision 97)
@@ -0,0 +1,151 @@
+package com.framsticks.hosting;
+
+import static com.framsticks.util.lang.Strings.assureNotEmpty;
+
+import com.framsticks.communication.*;
+import com.framsticks.communication.queries.ApplicationRequest;
+import com.framsticks.communication.queries.CallRequest;
+import com.framsticks.communication.queries.GetRequest;
+import com.framsticks.communication.queries.InfoRequest;
+import com.framsticks.communication.queries.SetRequest;
+import com.framsticks.core.Mode;
+import com.framsticks.core.Tree;
+import com.framsticks.core.Path;
+import com.framsticks.params.*;
+import com.framsticks.params.types.ProcedureParam;
+import com.framsticks.parsers.Savers;
+import com.framsticks.util.FramsticksException;
+import com.framsticks.util.dispatching.AbstractJoinable;
+import com.framsticks.util.dispatching.Dispatching;
+import com.framsticks.util.dispatching.FutureHandler;
+import com.framsticks.util.dispatching.Joinable;
+import com.framsticks.util.dispatching.JoinableParent;
+import com.framsticks.util.dispatching.JoinableState;
+import static com.framsticks.core.TreeOperations.*;
+
+import java.net.Socket;
+import java.util.LinkedList;
+import java.util.List;
+
+/**
+ * @author Piotr Sniegowski
+ */
+public class ClientAtServer extends AbstractJoinable implements RequestHandler, JoinableParent {
+
+	protected final Server server;
+	protected final Tree tree;
+	protected final ServerSideManagedConnection connection;
+
+	public ClientAtServer(Server server, Socket socket) {
+		this.server = server;
+		this.tree = server.hosted;
+		this.connection = new ServerSideManagedConnection(socket, this);
+	}
+
+	@Override
+	public String getName() {
+		return connection + " to " + server;
+	}
+
+	@Override
+	public void handle(final ApplicationRequest request, final ServerSideResponseFuture responseCallback) {
+		assureNotEmpty(request.getPath());
+
+		resolve(tree, request.getPath(), new FutureHandler<Path>(responseCallback) {
+			@Override
+			protected void result(final Path path) {
+
+				// final AccessInterface access = tree.prepareAccess(path);
+				final AccessInterface access = bindAccess(path);
+
+				if (request instanceof SetRequest) {
+					SetRequest setRequest = (SetRequest) request;
+					//TODO Primitive Param?
+					tree.set(path, access.getFramsClass().getParamEntry(setRequest.getField(), PrimitiveParam.class), setRequest.getValue(), new FutureHandler<Integer>(responseCallback) {
+						@Override
+						protected void result(Integer flag) {
+							responseCallback.pass(new Response(true, Flags.write(flag, null), null));
+
+						}
+					});
+					return;
+				}
+
+				if (request instanceof GetRequest) {
+					tree.get(path, Mode.FETCH, new FutureHandler<Object>(responseCallback) {
+
+						@Override
+						protected void result(Object result) {
+							if (result != access.getSelected()) {
+								throw new FramsticksException().msg("mismatch objects during fetch").arg("path", path);
+							}
+							// TODO Auto-generated method stub
+							List<File> files = new LinkedList<File>();
+							ListSink sink = new ListSink();
+							access.save(sink);
+							files.add(new File(path.getTextual(), new ListSource(sink.getOut())));
+							responseCallback.pass(new Response(true, "", files));
+						}
+					});
+
+					return;
+				}
+				if (request instanceof CallRequest) {
+					final CallRequest callRequest = (CallRequest) request;
+					tree.call(path, access.getFramsClass().getParamEntry(callRequest.getProcedure(), ProcedureParam.class), callRequest.getArguments().toArray(), new FutureHandler<Object>(responseCallback) {
+						@Override
+						protected void result(Object result) {
+							ListSink sink = new ListSink();
+							sink.print("Result:").breakLine();
+							sink.print("value:").print("[");
+							if (result != null) {
+								sink.print(result);
+							}
+							sink.print("]");
+
+							responseCallback.pass(new Response(true, "", File.single(new File("", new ListSource(sink.getOut())))));
+						}
+					});
+					return;
+				}
+				if (request instanceof InfoRequest) {
+					FramsClass framsClass = getInfo(path);
+					if (framsClass == null) {
+						throw new FramsticksException().msg("info should be available");
+					}
+					responseCallback.pass(new Response(true, null, File.single(new File(path.getTextual(), new ListSource(Savers.saveFramsClass(new ListSink(), framsClass).getOut())))));
+					return;
+				}
+
+				throw new FramsticksException().msg("invalid request type: " + request.getCommand());
+			}
+		});
+
+	}
+
+	@Override
+	protected void joinableStart() {
+		Dispatching.use(connection, this);
+	}
+
+	@Override
+	protected void joinableInterrupt() {
+		Dispatching.drop(connection, this);
+	}
+
+	@Override
+	protected void joinableFinish() {
+	}
+
+	@Override
+	protected void joinableJoin() throws InterruptedException {
+		Dispatching.join(connection);
+	}
+
+	@Override
+	public void childChangedState(Joinable joinable, JoinableState state) {
+		proceedToState(state);
+	}
+
+
+}
Index: java/main/src/main/java/com/framsticks/hosting/Server.java
===================================================================
--- java/main/src/main/java/com/framsticks/hosting/Server.java	(revision 96)
+++ java/main/src/main/java/com/framsticks/hosting/Server.java	(revision 97)
@@ -4,5 +4,5 @@
 import org.apache.log4j.Logger;
 
-import com.framsticks.core.Instance;
+import com.framsticks.core.Tree;
 import com.framsticks.params.annotations.AutoAppendAnnotation;
 import com.framsticks.params.annotations.FramsClassAnnotation;
@@ -17,4 +17,5 @@
 import com.framsticks.util.dispatching.RunAt;
 import com.framsticks.util.dispatching.Task;
+import com.framsticks.util.dispatching.ThrowExceptionHandler;
 
 import java.io.IOException;
@@ -32,6 +33,6 @@
 
 	protected ServerSocket acceptSocket;
-	protected Instance hosted;
-	protected final JoinableCollection<InstanceClient> clients = new JoinableCollection<InstanceClient>();
+	protected Tree hosted;
+	protected final JoinableCollection<ClientAtServer> clients = new JoinableCollection<ClientAtServer>();
 
 	public static class Accept {
@@ -80,12 +81,12 @@
 	 * @return the hosted
 	 */
-	public Instance getHosted() {
+	public Tree getHosted() {
 		return hosted;
 	}
 
 	@AutoAppendAnnotation
-	public void setHosted(Instance hosted) {
+	public void setHosted(Tree hosted) {
 		if (this.hosted != null) {
-			throw new FramsticksException().msg("hosted instance is already set").arg("current", this.hosted);
+			throw new FramsticksException().msg("hosted tree is already set").arg("current", this.hosted);
 		}
 		this.hosted = hosted;
@@ -123,7 +124,8 @@
 			return;
 		}
-		acceptThread.dispatch(new RunAt<Accept>() {
+		//TODO TEH
+		acceptThread.dispatch(new RunAt<Accept>(ThrowExceptionHandler.getInstance()) {
 			@Override
-			public void run() {
+			protected void runAt() {
 				try {
 					log.debug("accepting");
@@ -131,8 +133,8 @@
 					assert socket != null;
 					log.debug("accepted socket: " + socket.getInetAddress().getHostAddress());
-					hosted.dispatch(new RunAt<Instance>() {
+					hosted.dispatch(new RunAt<Tree>(this) {
 						@Override
-						public void run() {
-							InstanceClient client = new InstanceClient(Server.this, socket);
+						protected void runAt() {
+							ClientAtServer client = new ClientAtServer(Server.this, socket);
 							clients.add(client);
 							log.info("client connected: " + client);
@@ -148,7 +150,7 @@
 
 	protected void tryBind(int when) {
-		acceptThread.dispatch(new Task<Accept>(when) {
+		acceptThread.dispatch(new Task<Accept>(ThrowExceptionHandler.getInstance(), when) {
 			@Override
-			public void run() {
+			protected void runAt() {
 				try {
 					acceptSocket.bind(new InetSocketAddress(port));
Index: java/main/src/main/java/com/framsticks/model/f0/Schema.java
===================================================================
--- java/main/src/main/java/com/framsticks/model/f0/Schema.java	(revision 96)
+++ java/main/src/main/java/com/framsticks/model/f0/Schema.java	(revision 97)
@@ -35,5 +35,5 @@
 	}
 
-	protected static Schema defaultSchema;
+	private static Schema defaultSchema;
 
 	public synchronized static Schema getDefaultSchema() {
Index: java/main/src/main/java/com/framsticks/params/AccessInterface.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/AccessInterface.java	(revision 96)
+++ java/main/src/main/java/com/framsticks/params/AccessInterface.java	(revision 97)
@@ -56,5 +56,5 @@
 	void save(SinkInterface sink);
 
-	void load(SourceInterface stream) throws Exception;
+	void load(SourceInterface stream);
 
 	/**
Index: java/main/src/main/java/com/framsticks/params/ListAccess.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/ListAccess.java	(revision 96)
+++ java/main/src/main/java/com/framsticks/params/ListAccess.java	(revision 97)
@@ -63,5 +63,5 @@
 
 	@Override
-	public void load(SourceInterface stream) throws Exception {
+	public void load(SourceInterface stream) {
 	}
 
Index: java/main/src/main/java/com/framsticks/params/ParamBuilder.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/ParamBuilder.java	(revision 96)
+++ java/main/src/main/java/com/framsticks/params/ParamBuilder.java	(revision 97)
@@ -504,5 +504,5 @@
 	}
 
-	private static Pattern addressPattern = Pattern.compile("^([^\\(]+)?\\(([^\\)]*)\\)$");
+	private static Pattern signaturePattern = Pattern.compile("^([^\\(]+)?\\(([^\\)]*)\\)$");
 
 	public ParamBuilder signature(String signature) {
@@ -513,5 +513,5 @@
 			return this;
 		}
-		Matcher matcher = addressPattern.matcher(signature);
+		Matcher matcher = signaturePattern.matcher(signature);
 		if (!matcher.matches()) {
 			throw new FramsticksException().msg("invalid signature");
Index: java/main/src/main/java/com/framsticks/params/SimpleAbstractAccess.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/SimpleAbstractAccess.java	(revision 96)
+++ java/main/src/main/java/com/framsticks/params/SimpleAbstractAccess.java	(revision 97)
@@ -1,5 +1,4 @@
 package com.framsticks.params;
 
-import java.io.IOException;
 import java.util.Collection;
 
@@ -149,7 +148,4 @@
 	public void setMin(int i) {
 		PrimitiveParam<?> entry = framsClass.getParamEntry(i, PrimitiveParam.class);
-		if (entry == null) {
-			return;
-		}
 		Object min = entry.getMin(entry.getStorageType());
 		if (min != null) {
@@ -168,7 +164,4 @@
 	public void setMax(int i) {
 		PrimitiveParam<?> entry = framsClass.getParamEntry(i, PrimitiveParam.class);
-		if (entry == null) {
-			return;
-		}
 		Object max = entry.getMax(entry.getStorageType());
 		if (max != null) {
@@ -205,6 +198,5 @@
 	}
 
-	private Entry readEntry(SourceInterface source)
-			throws IOException {
+	private Entry readEntry(SourceInterface source) {
 
 		String line;
@@ -252,5 +244,5 @@
 
 	@Override
-	public void load(SourceInterface source) throws Exception {
+	public void load(SourceInterface source) {
 		//TODO not clearing values, because get from manager gives only fields, not children
 		//this.clearValues();
Index: java/main/src/main/java/com/framsticks/parsers/F0Parser.java
===================================================================
--- java/main/src/main/java/com/framsticks/parsers/F0Parser.java	(revision 96)
+++ java/main/src/main/java/com/framsticks/parsers/F0Parser.java	(revision 97)
@@ -19,4 +19,5 @@
 import com.framsticks.params.PrimitiveParam;
 import com.framsticks.util.FramsticksException;
+import com.framsticks.util.io.Encoding;
 import com.framsticks.util.lang.Containers;
 import com.framsticks.util.lang.Pair;
@@ -85,5 +86,5 @@
 	public List<AccessInterface> parse() {
 
-		try (InputStreamReader reader = new InputStreamReader(is, "UTF-8")) {
+		try (InputStreamReader reader = new InputStreamReader(is, Encoding.getDefaultCharset())) {
 			BufferedReader br = new BufferedReader(reader);
 			while (br.ready()) {
Index: java/main/src/main/java/com/framsticks/parsers/MultiParamLoader.java
===================================================================
--- java/main/src/main/java/com/framsticks/parsers/MultiParamLoader.java	(revision 96)
+++ java/main/src/main/java/com/framsticks/parsers/MultiParamLoader.java	(revision 97)
@@ -4,6 +4,4 @@
 import org.apache.log4j.Logger;
 
-import java.io.FileNotFoundException;
-import java.io.IOException;
 import java.util.*;
 
@@ -110,5 +108,5 @@
 	 * Starts reading the file.
 	 */
-	public Status go() throws Exception {
+	public Status go() {
 		log.trace("go");
 
@@ -159,5 +157,13 @@
 				continue;
 			}
-			log.warn("unknown line: " + currentLine);
+
+			// log.warn("unknown line: " + currentLine);
+			changeStatus(Status.OnError);
+			if (action == LoopAction.Break) {
+				break;
+			}
+			if (action == LoopAction.Continue) {
+				continue;
+			}
 		}
 
@@ -170,5 +176,5 @@
 	 * @throws Exception
 	 */
-	private LoopAction tryReadObject() throws Exception {
+	private LoopAction tryReadObject() {
 		if (status == Status.BeforeObject
 				|| (status == Status.BeforeUnknown && lastAccessInterface != null)) {
@@ -201,5 +207,5 @@
 	 * Checks whether some additional file shouldn't be included.
 	 */
-	private LoopAction isIncludeLine(String line) throws FileNotFoundException {
+	private LoopAction isIncludeLine(String line) {
 		try {
 			// found comment
@@ -374,5 +380,5 @@
 	 * Returns from included file.
 	 */
-	private boolean returnFromIncluded() throws IOException {
+	private boolean returnFromIncluded() {
 		if (fileStack.size() == 0) {
 			return false;
Index: java/main/src/main/java/com/framsticks/parsers/XmlLoader.java
===================================================================
--- java/main/src/main/java/com/framsticks/parsers/XmlLoader.java	(revision 96)
+++ java/main/src/main/java/com/framsticks/parsers/XmlLoader.java	(revision 97)
@@ -64,7 +64,4 @@
 		AccessInterface access = registry.createAccess(name);
 
-		if (access == null) {
-			throw new FramsticksException().msg("failed to find access interface").arg("name", name);
-		}
 		Object object = access.createAccessee();
 		assert object != null;
Index: java/main/src/main/java/com/framsticks/portals/Portal.java
===================================================================
--- java/main/src/main/java/com/framsticks/portals/Portal.java	(revision 96)
+++ java/main/src/main/java/com/framsticks/portals/Portal.java	(revision 97)
@@ -2,7 +2,7 @@
 
 
-import com.framsticks.core.AbstractInstanceListener;
-import com.framsticks.core.Instance;
-import com.framsticks.core.InstanceUtils;
+import com.framsticks.core.AbstractTreeListener;
+import com.framsticks.core.Tree;
+import com.framsticks.core.TreeOperations;
 import com.framsticks.core.Path;
 import com.framsticks.params.annotations.FramsClassAnnotation;
@@ -10,7 +10,8 @@
 import com.framsticks.util.Logging;
 import com.framsticks.util.dispatching.Dispatching;
-import com.framsticks.util.dispatching.Future;
+import com.framsticks.util.dispatching.FutureHandler;
 import com.framsticks.util.dispatching.JoinableCollection;
 import com.framsticks.util.dispatching.RunAt;
+import com.framsticks.util.dispatching.ThrowExceptionHandler;
 
 import org.apache.log4j.Logger;
@@ -21,5 +22,5 @@
  */
 @FramsClassAnnotation
-public class Portal extends JoinableCollection<Instance> {
+public class Portal extends JoinableCollection<Tree> {
 
 	private final static Logger log = Logger.getLogger(Portal.class.getName());
@@ -33,20 +34,20 @@
 	// @Override
 	// public void run() {
-	// 	super.run();
-	// 	new PeriodicTask<Portal>(this, 1000) {
+	//	super.run();
+	//	new PeriodicTask<Portal>(this, 1000) {
 
-	// 		@Override
-	// 		public void run() {
-	// 			++counter;
-	// 			log.debug("counter is now: " + counter);
-	// 			again();
-	// 		}
-	// 	};
+	//		@Override
+	//		public void run() {
+	//			++counter;
+	//			log.debug("counter is now: " + counter);
+	//			again();
+	//		}
+	//	};
 	// }
 
 	@Override
-	public void add(final Instance instance) {
-		super.add(instance);
-		instance.addListener(new AbstractInstanceListener() {
+	public void add(final Tree tree) {
+		super.add(tree);
+		tree.addListener(new AbstractTreeListener() {
 			@Override
 			public void onRun(Exception e) {
@@ -59,8 +60,8 @@
 				}
 				final String path = "/simulator/genepools/groups/0/genotypes";
-				instance.dispatch(new RunAt<Instance>() {
+				tree.dispatch(new RunAt<Tree>(ThrowExceptionHandler.getInstance()) {
 					@Override
-					public void run() {
-						InstanceUtils.resolve(instance, path, new Future<Path>(Logging.logger(log, "resolve", path)) {
+					protected void runAt() {
+						TreeOperations.resolve(tree, path, new FutureHandler<Path>(Logging.logger(log, "resolve", path)) {
 							@Override
 							public void result(Path result) {
Index: java/main/src/main/java/com/framsticks/remote/RecursiveFetcher.java
===================================================================
--- java/main/src/main/java/com/framsticks/remote/RecursiveFetcher.java	(revision 96)
+++ java/main/src/main/java/com/framsticks/remote/RecursiveFetcher.java	(revision 97)
@@ -1,5 +1,7 @@
 package com.framsticks.remote;
 
-import static com.framsticks.core.InstanceUtils.*;
+import static com.framsticks.core.TreeOperations.*;
+
+import com.framsticks.core.Mode;
 import com.framsticks.core.Node;
 import com.framsticks.core.Path;
@@ -7,9 +9,10 @@
 import com.framsticks.params.CompositeParam;
 import com.framsticks.params.FramsClass;
-import com.framsticks.core.Instance;
+import com.framsticks.core.Tree;
 import com.framsticks.util.dispatching.Future;
+import com.framsticks.util.dispatching.FutureHandler;
+import com.framsticks.util.dispatching.ThrowExceptionHandler;
 import com.framsticks.util.FramsticksException;
 import com.framsticks.util.Logging;
-import com.framsticks.util.StateFunctor;
 import com.framsticks.util.Stopwatch;
 import org.apache.log4j.Logger;
@@ -24,12 +27,12 @@
 	private final static Logger log = Logger.getLogger(RecursiveFetcher.class.getName());
 
-	protected final Instance instance;
-	protected final StateFunctor stateFunctor;
+	protected final Tree tree;
+	protected final Future<Void> future;
 	protected int dispatched;
 	protected final Stopwatch stopwatch = new Stopwatch();
 
-	public RecursiveFetcher(Instance instance, final Path path, StateFunctor stateFunctor) {
-		this.instance = instance;
-		this.stateFunctor = stateFunctor;
+	public RecursiveFetcher(Tree tree, final Path path, Future<Void> future) {
+		this.tree = tree;
+		this.future = future;
 		dispatched = 1;
 		process(path);
@@ -37,11 +40,11 @@
 
 	protected void finished() {
-		assert instance.isActive();
+		assert tree.isActive();
 		log.info("recursively fetched in " + stopwatch);
-		stateFunctor.call();
+		future.pass(null);
 	}
 
 	protected void process(final Path path) {
-		assert instance.isActive();
+		assert tree.isActive();
 		if (path == null || !path.isResolved()) {
 			log.warn("path " + path + " is not resolved - skipping");
@@ -55,7 +58,7 @@
 				if (childPath.isResolved() && getInfoFromCache(childPath) != null) {
 					++dispatched;
-					instance.dispatch(new RunAt<Instance>() {
+					tree.dispatch(new RunAt<Tree>(ThrowExceptionHandler.getInstance()) {
 						@Override
-						public void run() {
+						protected void runAt() {
 							fetch(childPath);
 						}
@@ -64,8 +67,8 @@
 				}
 				++dispatched;
-				instance.resolve(childPath, new Future<Path>(Logging.logger(log, "resolve", RecursiveFetcher.this)) {
+				tree.resolve(childPath, new FutureHandler<Path>(Logging.logger(log, "resolve", RecursiveFetcher.this)) {
 					@Override
 					protected void result(Path result) {
-						assert instance.isActive();
+						assert tree.isActive();
 						fetch(result);
 					}
@@ -80,5 +83,6 @@
 
 	protected void fetch(final Path path) {
-		instance.fetchValues(path, new StateFunctor() {
+		tree.get(path, Mode.FETCH, new Future<Object>() {
+
 			@Override
 			public void handle(FramsticksException e) {
@@ -88,5 +92,5 @@
 
 			@Override
-			public void call() {
+			protected void result(Object object) {
 				process(path);
 			}
